/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:41:46 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.adexchangebuyer.model;

/**
 * The configuration data for an Ad Exchange performance report list. TODO(nathanbullock): need to
 * add some release tests before releasing this. https://sites.google.com/a/google.com/adx-
 * integration/Home/engineering/binary-releases/rtb-api-release
 * https://cs.corp.google.com/#piperdepot/google3/contentads/adx/tools/rtb_api/adxrtb.py
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ad Exchange Buyer API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class PerformanceReport extends com.google.api.client.json.GenericJson {

  /**
   * The quota limits for this account.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("QuotaConfiguredLimit")
  private java.lang.Double quotaConfiguredLimit;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("QuotaThrottledLimit")
  private java.lang.Double quotaThrottledLimit;

  /**
   * Resource type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The Nth percentile round trip latency(ms) as perceived from Google servers for the duration
   * period covered by the report.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double latency50thPercentile;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double latency85thPercentile;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double latency95thPercentile;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double noQuotaInRegion;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double outOfQuota;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double pixelMatchRequests;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double pixelMatchResponses;

  /**
   * The trading location of this data.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String region;

  /**
   * Timestamp of the starting time of this performance data.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long timestamp;

  /**
   * The quota limits for this account.
   * @return value or {@code null} for none
   */
  public java.lang.Double getQuotaConfiguredLimit() {
    return quotaConfiguredLimit;
  }

  /**
   * The quota limits for this account.
   * @param quotaConfiguredLimit quotaConfiguredLimit or {@code null} for none
   */
  public PerformanceReport setQuotaConfiguredLimit(java.lang.Double quotaConfiguredLimit) {
    this.quotaConfiguredLimit = quotaConfiguredLimit;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.Double getQuotaThrottledLimit() {
    return quotaThrottledLimit;
  }

  /**
   * @param quotaThrottledLimit quotaThrottledLimit or {@code null} for none
   */
  public PerformanceReport setQuotaThrottledLimit(java.lang.Double quotaThrottledLimit) {
    this.quotaThrottledLimit = quotaThrottledLimit;
    return this;
  }

  /**
   * Resource type.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Resource type.
   * @param kind kind or {@code null} for none
   */
  public PerformanceReport setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The Nth percentile round trip latency(ms) as perceived from Google servers for the duration
   * period covered by the report.
   * @return value or {@code null} for none
   */
  public java.lang.Double getLatency50thPercentile() {
    return latency50thPercentile;
  }

  /**
   * The Nth percentile round trip latency(ms) as perceived from Google servers for the duration
   * period covered by the report.
   * @param latency50thPercentile latency50thPercentile or {@code null} for none
   */
  public PerformanceReport setLatency50thPercentile(java.lang.Double latency50thPercentile) {
    this.latency50thPercentile = latency50thPercentile;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.Double getLatency85thPercentile() {
    return latency85thPercentile;
  }

  /**
   * @param latency85thPercentile latency85thPercentile or {@code null} for none
   */
  public PerformanceReport setLatency85thPercentile(java.lang.Double latency85thPercentile) {
    this.latency85thPercentile = latency85thPercentile;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.Double getLatency95thPercentile() {
    return latency95thPercentile;
  }

  /**
   * @param latency95thPercentile latency95thPercentile or {@code null} for none
   */
  public PerformanceReport setLatency95thPercentile(java.lang.Double latency95thPercentile) {
    this.latency95thPercentile = latency95thPercentile;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.Double getNoQuotaInRegion() {
    return noQuotaInRegion;
  }

  /**
   * @param noQuotaInRegion noQuotaInRegion or {@code null} for none
   */
  public PerformanceReport setNoQuotaInRegion(java.lang.Double noQuotaInRegion) {
    this.noQuotaInRegion = noQuotaInRegion;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.Double getOutOfQuota() {
    return outOfQuota;
  }

  /**
   * @param outOfQuota outOfQuota or {@code null} for none
   */
  public PerformanceReport setOutOfQuota(java.lang.Double outOfQuota) {
    this.outOfQuota = outOfQuota;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.Double getPixelMatchRequests() {
    return pixelMatchRequests;
  }

  /**
   * @param pixelMatchRequests pixelMatchRequests or {@code null} for none
   */
  public PerformanceReport setPixelMatchRequests(java.lang.Double pixelMatchRequests) {
    this.pixelMatchRequests = pixelMatchRequests;
    return this;
  }

  /**
   * @return value or {@code null} for none
   */
  public java.lang.Double getPixelMatchResponses() {
    return pixelMatchResponses;
  }

  /**
   * @param pixelMatchResponses pixelMatchResponses or {@code null} for none
   */
  public PerformanceReport setPixelMatchResponses(java.lang.Double pixelMatchResponses) {
    this.pixelMatchResponses = pixelMatchResponses;
    return this;
  }

  /**
   * The trading location of this data.
   * @return value or {@code null} for none
   */
  public java.lang.String getRegion() {
    return region;
  }

  /**
   * The trading location of this data.
   * @param region region or {@code null} for none
   */
  public PerformanceReport setRegion(java.lang.String region) {
    this.region = region;
    return this;
  }

  /**
   * Timestamp of the starting time of this performance data.
   * @return value or {@code null} for none
   */
  public java.lang.Long getTimestamp() {
    return timestamp;
  }

  /**
   * Timestamp of the starting time of this performance data.
   * @param timestamp timestamp or {@code null} for none
   */
  public PerformanceReport setTimestamp(java.lang.Long timestamp) {
    this.timestamp = timestamp;
    return this;
  }

  @Override
  public PerformanceReport set(String fieldName, Object value) {
    return (PerformanceReport) super.set(fieldName, value);
  }

  @Override
  public PerformanceReport clone() {
    return (PerformanceReport) super.clone();
  }

}
